<template>
  <dropdown :isBtnActive="filter.selectedDate !== null">

    <template v-slot:btn>

      <template v-if="filter.selectedDate === null">
        {{ filter.name }}
        <icon-small-arrow class="dropdown__icon"/>
      </template>

      <template v-else>
        {{ formatDates(filter.selectedDate) }}

        <span @click="clearValue" class="dropdown__icon-wrapper">
          <icon-cross class="dropdown__icon"/>
        </span>
      </template>

    </template>

    <template v-slot:body>

      <div class="date-dropdown__datepicker-wrapper" ref="test">
        <client-only>
          <v-date-picker
            v-if="!rerenderCalendar"
            v-model="date"
            class="datepicker date-dropdown__datepicker"
            :locale="{ id: 'ru', firstDayOfWeek: 2, masks: { weekdays: 'WW' } }"
            :min-date="new Date()"
            mode="single"
            is-expanded
            is-inline
          />
        </client-only>
      </div>

      <button type="button"
              class="button button--green date-dropdown__btn"
              @click="setActiveDates">
        Применить
      </button>

    </template>

  </dropdown>
</template>

<script>
  import Dropdown from './Dropdown';
  import IconSmallArrow from '../icons/IconSmallArrow';
  import IconCross from '../icons/IconCross';

  import closeDropdowns from '../../assets/js/helpers/close-dropdowns';
  import { months } from '../../assets/js/helpers/consts';

  export default {
    name: 'DateDropdown',
    props: {
      filter: {
        type: Object,
        required: true
      }
    },
    components: {
      IconCross,
      IconSmallArrow,
      Dropdown,
    },
    data: () => ({
      date: null,
      rerenderCalendar: false,
      canWatch: false
    }),

    beforeMount() {
      this.date = this.filter.selectedDate;

      this.$nextTick(() => {
        this.canWatch = true;
      });
    },

    watch: {
      date() {
        if (!this.canWatch) return;

        const highlighedDates = this.date
          ? this.$el.querySelectorAll(`.vc-day:not(id-${this.date.toLocaleDateString().replace(/(\d+).(\d+).(\d+)/, '$3-$2-$1')}) .vc-highlights`)
          : this.$el.querySelectorAll(`.vc-day .vc-highlights`);

        highlighedDates.forEach((highlighedDate) =>
          highlighedDate.remove());

        if (this.date) {
          const needToHighlightDate = this.$el.querySelector(`.vc-day.id-${this.date.toLocaleDateString().replace(/(\d+).(\d+).(\d+)/, '$3-$2-$1')} > .vc-h-full`);

          needToHighlightDate.insertAdjacentHTML('afterbegin', '<div class="vc-highlights vc-day-layer"></div>')
        }
      },

      filter: {
        deep: true,

        handler() {
          if (this.filter.selectedDate === null) {
            this.date = null;

            // Перерендериваем календарь для сброса подсветки
            // (плагином не предусмотрен такой функционал для inline календарей)
            this.rerenderCalendar = true;
            setTimeout(() => this.rerenderCalendar = false)
          }
        }
      }
    },
    methods: {
      clearValue(event) {
        event.stopPropagation();
        this.$emit('clearValue');

        // обнуляем внутреннее значение даты (v-model для плагина календаря),
        // закрываем окно дропдауна
        this.date = null;
        closeDropdowns();

        // Перерендериваем календарь для сброса подсветки
        // (плагином не предусмотрен такой функционал для inline календарей)
        this.rerenderCalendar = true;
        setTimeout(() => this.rerenderCalendar = false)
      },

      setActiveDates() {
        if (this.date === null) return;

        this.$emit('setActiveDates', this.date);
        closeDropdowns();
      },

      formatDates(date) {
        return `${date.getDate()} ${months[date.getMonth()]}`;
      }
    }
  }
</script>

<style scoped lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .date-dropdown {

    &__btn {
      width: 100%;
    }

    &__checks {
      display: flex;
      align-items: center;

      margin-top: rem(20);
      margin-bottom: rem(30);

      .checkbox + .checkbox {
        margin-left: rem(30);
      }
    }

    &__datepicker {
      padding-bottom: rem(14);
    }

    &__datepicker-wrapper {
      height: rem(345);
    }

  }
</style>
